package edu.ehu.GB.MIF.nasdaqGame;

import java.sql.SQLException;
import java.util.Map;
import java.util.TreeMap;

/**
 *
 * @author German
 */
public class Cartera {

    private double saldo;
    private Map<String,Integer> cartera=new TreeMap<>();

    public Cartera(double saldo) {
        this.saldo = saldo;
    }

    public double getSaldo() {
        return saldo;
    }

    public int posicion(String ticker){
        Integer i=cartera.get(ticker);
        return i==null?0:i;
    }
    
    public double valor(String ticker, String tradeInstant) throws SQLException{
        Integer i=cartera.get(ticker);
        return i==null?0:i* Nasdaq.cotizacion(ticker, tradeInstant);
    }
    
    public double valor(String tradeInstant) throws SQLException{
        double valor=0;
        for (String ticker:cartera.keySet()){
            valor+=cartera.get(ticker)* Nasdaq.cotizacion(ticker, tradeInstant);;
        }
        return valor;
    }
    
    public void compra(String ticker, int cantidad, String tradeInstant) throws SQLException{
        double coste=Nasdaq.compra (ticker, cantidad, tradeInstant);
        if (coste>saldo) return;
        saldo-=coste;
        Integer i=cartera.get(ticker);
        if (i==null) cartera.put(ticker,cantidad);
        else cartera.put(ticker, i+cantidad);
    }
    
    public void venta(String ticker, int cantidad, String tradeInstant) throws SQLException{
        System.out.println("vender");
        Integer i=cartera.get(ticker);
        if (i==null || i<cantidad) return;
        double coste= Nasdaq.venta(ticker, cantidad, tradeInstant);
        saldo+=coste;
        cartera.put(ticker, i-cantidad);
    }
    
}
